    package com.croftsoft.apps.tpu;
    
    import java.util.*;

    /***********************************************************************
    * Demonstration of using ThreePhaseUpdate incorrectly.
    * 
    * This version is incorrect because a cell mutates before another has a
    * chance to access it during the update.
    * 
    * @version
    *   $Id: ThreePhaseUpdateDemo0.java 23 2009-07-04 03:55:36Z croft $
    * @since
    *   2009-06-05
    * @author
    *   <a href="http://www.CroftSoft.com/">David Wallace Croft</a>
    ***********************************************************************/

    public final class  ThreePhaseUpdateDemo0
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    {
      
    private static final int
      GRID_WIDTH  = 30,
      GRID_HEIGHT = 30;
      
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////

    public static void  main ( final String [ ]  args )
    ////////////////////////////////////////////////////////////////////////
    {
      final Random  random = new Random ( );
      
      final ThreePhaseUpdateGrid  grid
        = new ThreePhaseUpdateGrid ( random, GRID_WIDTH, GRID_HEIGHT );
      
      for ( int  row = 0; row < GRID_HEIGHT; row++ )
      {
        for ( int  column = 0; column < GRID_WIDTH; column++ )
        {
          final ThreePhaseUpdate
            threePhaseUpdate = grid.getCell ( row, column );
          
          threePhaseUpdate.access ( );
          
          threePhaseUpdate.digest ( );
          
          threePhaseUpdate.mutate ( );
        }
      }
    }
    
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    }