    package com.croftsoft.apps.tpu;

    /***********************************************************************
    * Three Phase Update.
    * 
    * For a tutorial on the use of the Three Phase Update (TPU) pattern,
    * please see Croft, "Concurrent Java Simulations Using Three Phase
    * Update", 2009-07-04, <a target="blank"
    * href="http://www.CroftSoft.com/library/tutorials/tpu/">
    *       http://www.CroftSoft.com/library/tutorials/tpu/</a>.
    * 
    * @version
    *   $Id: ThreePhaseUpdate.java 25 2009-07-04 05:35:25Z croft $
    * @since
    *   2009-05-10
    * @author
    *   <a href="http://www.CroftSoft.com/">David Wallace Croft</a>
    ***********************************************************************/

    public interface  ThreePhaseUpdate
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    {
      
    void  access ( );
    
    void  digest ( );
    
    void  mutate ( );
    
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    }